import functions as fun
import time
import serial

def create_motech(motech):

    portTab = ['COM1', 'COM2', 'COM3']
    baudrate = 2400

    try:
        motech.port = 'COM3'
    except:
        for i in portTab:
            try:
                motech.port = i
                break
            except:
                continue

    motech.baudrate = baudrate
    motech.polarity = None
    motech.bytesize = serial.EIGHTBITS
    motech.stopbits = serial.STOPBITS_ONE
    motech.timeout = 1
    # motech.write_timeout = 2
    motech.parity = serial.PARITY_NONE

    try:
        motech.open()
        return motech
    except:
        fun.report_the_bug("CAN'T OPEN THE PORT")

    # and now, set up track
    motech.readline()
    time.sleep(0.1)
    motech.write(bytearray('OK\r\n', 'utf-8'))
    time.sleep(0.1)
    motech.write(bytearray('TRACK0\r\n', 'utf-8'))
    time.sleep(0.1)
    motech.readline()


def disable_outputs(serialObject):
    serialObject.readline()
    time.sleep(0.1)
    serialObject.write(bytearray('OK\r\n', 'utf-8'))
    time.sleep(0.1)
    serialObject.write(bytearray('OUT0\r\n', 'utf-8'))
    time.sleep(0.1)
    serialObject.readline()


def enable_outputs(serialObject):
    serialObject.readline()
    time.sleep(0.1)
    serialObject.write(bytearray('OK\r\n', 'utf-8'))
    time.sleep(0.1)
    serialObject.write(bytearray('OUT1\r\n', 'utf-8'))
    time.sleep(0.1)
    serialObject.readline()


def set_up_device(serialObject):
    serialObject.readline()
    time.sleep(0.1)
    serialObject.write(bytearray('OK\r\n', 'utf-8'))
    time.sleep(0.1)
    serialObject.write(bytearray('VOUT0\r\n', 'utf-8'))
    time.sleep(0.1)
    serialObject.readline()


def update_device(serialObject, voltage):
    serialObject.readline()
    time.sleep(0.1)
    serialObject.write(bytearray('OK\r\n', 'utf-8'))
    time.sleep(0.1)
    serialObject.write(bytearray('VSET1 ' + str(voltage) + '\r\n', 'utf-8'))
    time.sleep(0.1)
    serialObject.readline()


def finish(serialObj):
    disable_outputs(serialObj)
    serialObj.close()


def send(serialObject, message):
    try:
        serialObject.write(bytearray(message, 'utf-8'))

        serialObject.flush()

        # time.sleep(1) # we use flush() instead of time.sleep()

    except:
        fun.report_the_bug("Nie udalo sie wyslac")
        raise
